

Include "start.bb"

Global displaywidth = GraphicsWidth()
Global displayheight = GraphicsHeight()


;global entities
Global camera
Global light
Global thesun
Global planet

;original sprites for lens flares
Global lensflareorig1
Global lensflareorig2
Global lensflareorig3
Global lensflareorig4

;lens flares
Global lensflare1
Global lensflare2
Global lensflare3
Global lensflare4
Global lensflare5
Global lensflare6
Global lensflare7

;are lens flares visible?
Global lensflaresvisible% = False

;hud overlay pivot
Global hudoverlay

;create hud overlay
CreateHudOverlay()

;load the lens sprites
LoadSprites()

;create the sun
thesun = CreateSphere(16)				;create it
ScaleEntity thesun, 50, 50, 50			;resize it
EntityRadius thesun, 50					;resize collision sphere
EntityPickMode thesun, 1, True			;make pick mode sphere and make the entity obscure others
EntityColor thesun, 128, 128, 0			;change entity's colour
PositionEntity thesun,1000,600,-1000


;light it up
light = CreateLight()
LightColor light, 196, 196, 0




























Include"tree.bb"
Include"global.bb"
;Include"functions.bb"















While Not KeyHit(1)



;update lens flare effect
	UpdateLensFlares()
	UpdateGame()
	UpdateWorld
	For c.camera=Each camera
		Updatecamera( c )
	Next
	RenderWorld

	Flip
	
	

Wend

End





;--------- Functions -------------



Function UpdateGame()
	For p.Player=Each Player
		UpdatePlayer( p )
	Next
End Function

Function CreatePlayer.Player( x#,y#,z# )
	p.Player=New Player
	p\entity=CreatePivot()
	p\model=CopyEntity( player_model,p\entity )
	p\player_y=y
	PositionEntity p\entity,x,y,z
	EntityType p\entity,TYPE_PLAYER
	EntityRadius p\entity,2
	Return p



	
End Function

Function CreateSmartCamera.camera( entity )
	c.camera=New camera
	c\entity=entity
	c\camera=CreateCamera()

	c\target=CreatePivot( entity )
	PositionEntity c\target,0,5,-10
	EntityType c\target,TYPE_TARGET

	CameraRange c\camera,1,1000000
	c\heading=CreatePivot( entity )
	PositionEntity c\heading,0,0,20
	Return c
End Function

Function LoadGameObjects()

    
  level=LoadMesh( "map\1\999.b3d" )

	ScaleEntity level,.15,.15,.15
	EntityType level,TYPE_WALL

    player_model = LoadAnimMesh( "ROBOT\sonic555.3DS" ) 
    ScaleEntity player_model,.7,.9,.7
    LoadAnimSeq player_model, ("ROBOT\running.3DS" ) 
    TurnEntity player_model,0,-180,0 
    HideEntity player_model






	

End Function

Function MakeSkyBox( file$ )

m=CreateMesh()
;front face
b=LoadBrush( file$+"_FR.jpg",49 )
s=CreateSurface( m,b )
AddVertex s,-1,+1,-1,0,0:AddVertex s,+1,+1,-1,1,0
AddVertex s,+1,-1,-1,1,1:AddVertex s,-1,-1,-1,0,1
AddTriangle s,0,1,2:AddTriangle s,0,2,3
FreeBrush b
;right face
b=LoadBrush( file$+"_LF.jpg",49 )
s=CreateSurface( m,b )
AddVertex s,+1,+1,-1,0,0:AddVertex s,+1,+1,+1,1,0
AddVertex s,+1,-1,+1,1,1:AddVertex s,+1,-1,-1,0,1
AddTriangle s,0,1,2:AddTriangle s,0,2,3
FreeBrush b
;back face
b=LoadBrush( file$+"_BK.jpg",49 )
s=CreateSurface( m,b )
AddVertex s,+1,+1,+1,0,0:AddVertex s,-1,+1,+1,1,0
AddVertex s,-1,-1,+1,1,1:AddVertex s,+1,-1,+1,0,1
AddTriangle s,0,1,2:AddTriangle s,0,2,3
FreeBrush b
;left face
b=LoadBrush( file$+"_RT.jpg",49 )
s=CreateSurface( m,b )
AddVertex s,-1,+1,+1,0,0:AddVertex s,-1,+1,-1,1,0
AddVertex s,-1,-1,-1,1,1:AddVertex s,-1,-1,+1,0,1
AddTriangle s,0,1,2:AddTriangle s,0,2,3
FreeBrush b
;top face
b=LoadBrush( file$+"_UP.jpg",49 )
s=CreateSurface( m,b )
AddVertex s,-1,+1,+1,0,1:AddVertex s,+1,+1,+1,0,0
AddVertex s,+1,+1,-1,1,0:AddVertex s,-1,+1,-1,1,1
AddTriangle s,0,1,2:AddTriangle s,0,2,3
FreeBrush b

ScaleMesh m,100,100,100
FlipMesh m
EntityFX m,9
EntityOrder m,10
Return m

End Function

Function Updatecamera( c.camera )
    
	If KeyDown(30)
		TranslateEntity c\heading,0,-3,0
	Else If KeyDown(44)
		TranslateEntity c\heading,0,+3,0
	EndIf
	
	dx#=EntityX(c\target,True)-EntityX(c\camera,True)
	dy#=EntityY(c\target,True)-EntityY(c\camera,True)
	dz#=EntityZ(c\target,True)-EntityZ(c\camera,True)
	
	TranslateEntity c\camera,dx*ssp,dy*ssp,dz*ssp
	
	PointEntity c\camera,c\heading
		
	PositionEntity c\target,0,0,0
	ResetEntity c\target
	PositionEntity c\target,0,25,-35

    CameraFogMode  c\camera,1
	CameraClsColor c\camera,0,192,255
	CameraFogColor c\camera,0,192,255
	CameraFogRange c\camera,3000,6000

End Function

Function UpdatePlayer( p.Player )
	
	If KeyDown(203)	;left/right
		TurnEntity p\entity,0,5,0
	Else If KeyDown(205)
		TurnEntity p\entity,0,-5,0
	EndIf
	
	If KeyDown(200)		;forward
		If p\anim_speed<=0
			p\anim_speed=1.75
            Animate p\model, 1, 1.5, 1, 10 
		EndIf
   	    MoveEntity p\entity,0,0,1

	Else If KeyDown(208)	;back
		If p\anim_speed>=0
			p\anim_speed=-1.75
            Animate p\model, 1, 1.5, 1, 10 

		EndIf
		MoveEntity p\entity,0,0,-1

	Else If p\anim_speed	;stop animating
		p\anim_speed=0
        Animate p\model, 2, 1, 0, 10
	EndIf

	
ty#=EntityY(p\entity)
	y_vel#=(ty-p\player_y)
	p\player_y=ty
	
	If KeyHit(57)	;jump?
		y_vel=5	;2.4
	Else
		y_vel=y_vel-.5	;2
	EndIf
	TranslateEntity p\entity,0,y_vel,0
	
End Function

;-------------------------------------------------------------------------
;-- F U N C T I O N S
;-------------------------------------------------------------------------

;-------------------------------------------------------------------------
;-- Load sprites
;-------------------------------------------------------------------------
Function LoadSprites()

	;--lens flares
	lensflareorig1 = LoadSprite( "lens1.jpg" )
	If lensflareorig1 = 0 Then RuntimeError "file 'images\lens1.png' does not exist!"
	HideEntity lensflareorig1	;hide as these entitys only used for CopyEntity()

	lensflareorig2 = LoadSprite( "lens2.jpg" )
	If lensflareorig2 = 0 Then RuntimeError "file 'images\lens2.png' does not exist!"
	HideEntity lensflareorig2

	lensflareorig3 = LoadSprite( "lens3.jpg" )
	If lensflareorig3 = 0 Then RuntimeError "file 'images\lens3.png' does not exist!"
	HideEntity lensflareorig3

	lensflareorig4 = LoadSprite( "lens4.jpg" )
	If lensflareorig4 = 0 Then RuntimeError "file 'images\lens4.png' does not exist!"
	HideEntity lensflareorig4

End Function


;-------------------------------------------------------------------------
;-- Create entities for lens flare effect
;-------------------------------------------------------------------------
Function CreateLensFlares()

	lensflare1 = CopyEntity( lensflareorig1, hudoverlay ) ;primary flare
	ScaleSprite lensflare1, .5, .5		;scale according to screen size and size of sprite picture
	EntityAlpha lensflare1, .3			;set alpha blend amount
	EntityOrder lensflare1, -1			;place in front of other entitys
	HideEntity lensflare1				;hide initially
	
	lensflare2 = CopyEntity( lensflareorig2, hudoverlay ) ;first halo
	ScaleSprite lensflare2, .25, .25	;scale is 1/2 of lens flare #1
	EntityAlpha lensflare2, .3
	EntityOrder lensflare2, -2			;place in front of previous lens flare
	HideEntity lensflare2

	lensflare3 = CopyEntity( lensflareorig1, hudoverlay ) ;small burst
	ScaleSprite lensflare3, .125, .125	;scale is 1/4 of lens flare #1
	EntityAlpha lensflare3, .2
	EntityOrder lensflare3, -3			;place in front of previous lens flare
	HideEntity lensflare3

	lensflare4 = CopyEntity( lensflareorig2, hudoverlay ) ;next halo
	ScaleSprite lensflare4, .5, .5		;same scale as lens flare #1
	EntityAlpha lensflare4, .2
	EntityOrder lensflare4, -4			;place in front of previous lens flare
	HideEntity lensflare4

	lensflare5 = CopyEntity( lensflareorig1, hudoverlay ) ;next burst
	ScaleSprite lensflare5, .25, .25	;scale is 1/2 of lens flare #1
	EntityAlpha lensflare5, .2
	EntityOrder lensflare5, -5			;place in front of previous lens flare
	HideEntity lensflare5

	lensflare6 = CopyEntity( lensflareorig3, hudoverlay ) ;next halo
	ScaleSprite lensflare6, .125, .125	;scale is 1/4 of lens flare #1
	EntityAlpha lensflare6, .2
	EntityOrder lensflare6, -6			;place in front of previous lens flare
	HideEntity lensflare6

	lensflare7 = CopyEntity( lensflareorig1, hudoverlay ) ;next burst
	ScaleSprite lensflare7, .125, .125	;scale is 1/4 of lens flare #1
	EntityAlpha lensflare7, .2
	EntityOrder lensflare7, -7			;place in front of previous lens flare
	HideEntity lensflare7

	lensflaresvisible% = False			;lens flares are hidden by default

End Function


;-------------------------------------------------------------------------
;-- Update and display lens flares
;-------------------------------------------------------------------------
Function UpdateLensFlares()

	;-- is the sun in view? and make sure it's not blocked by other blocking entities
	If EntityInView( thesun, camera ) = True And EntityVisible( camera, thesun ) = True

		;determine sun visible x/y coords using camera 3d to 2d conversion
		CameraProject camera, EntityX(thesun,True), EntityY(thesun,True), EntityZ(thesun,True)
	    lx = ProjectedX() ;position on 2d screen
	    ly = ProjectedY()
	
		;determine center of screen
		cx = displaywidth / 2
		cy = displayheight / 2

		;determine vector from center to sun's x/y screen position
		vx = cx - lx
		vy = cy - ly
		If vx = 0 And vy = 0
			distance# = 1.0 ;to fix sqr(0) fail
		Else
			distance# = Sqr( (vx*vx)+(vy*vy) )	;determine length of vector (pythagoras)
		EndIf

		;normalise vector (determine 1 unit size in x and y coordinates)
		nx# = vx / distance#
		ny# = vy / distance#


		;== calculate lens flare positions
	
		;calculate lens flare 1 position (maximum distance)
		f1x = cx - (nx# * distance)
		f1y = cy - (ny# * distance)

		;calculate lens flare 2 position (half distance)
		f2x = cx - (nx# * (distance/2)) ;could optimize but leaving as divide for readability
		f2y = cy - (ny# * (distance/2))
	
		;calculate lens flare 3 position (one third of distance)
		f3x = cx - (nx# * (distance/3))
		f3y = cy - (ny# * (distance/3))
	
		;calculate lens flare 4 position (one eight distance)
		f4x = cx - (nx# * (distance/8))
		f4y = cy - (ny# * (distance/8))
	
		;calculate lens flare 5 position
		f5x = cx - (nx# * (-distance/2))
		f5y = cy - (ny# * (-distance/2))
	
		;calculate lens flare 6 position
		f6x = cx - (nx# * (-distance/4))
		f6y = cy - (ny# * (-distance/4))
	
		;calculate lens flare 7 position
		f7x = cx - (nx# * (-distance/5.5))
		f7y = cy - (ny# * (-distance/5.5))
	
	
		;=== position lens flares entities (relative to camera hud fixed pivot)

		PositionEntity lensflare1, f1x, f1y, 1
		PositionEntity lensflare2, f2x, f2y, 1
		PositionEntity lensflare3, f3x, f3y, 1
		PositionEntity lensflare4, f4x, f4y, 1
		PositionEntity lensflare5, f5x, f5y, 1
		PositionEntity lensflare6, f6x, f6y, 1
		PositionEntity lensflare7, f7x, f7y, 1

		;make flars visible? (if not already visible)
		If lensflaresvisible% = False
			ShowEntity lensflare1
			ShowEntity lensflare2
			ShowEntity lensflare3
			ShowEntity lensflare4
			ShowEntity lensflare5
			ShowEntity lensflare6
			ShowEntity lensflare7
			
			lensflaresvisible% = True
		EndIf


	;sun not visible from camera
	Else
		;lens flares previously visible? then hide them
		If lensflaresvisible% = True
			HideEntity lensflare1
			HideEntity lensflare2
			HideEntity lensflare3
			HideEntity lensflare4
			HideEntity lensflare5
			HideEntity lensflare6
			HideEntity lensflare7

			lensflaresvisible% = False
		EndIf
	EndIf

End Function


;-------------------------------------------------------------------------
;-- Create HUD overlay entity stuff
;-------------------------------------------------------------------------
;taken from overlay.bb written by simon@acid
Function CreateHudOverlay()

	hudoverlay = CreatePivot( camera ) 					;<<attach to camera!
	aspect# = Float(displayheight) / displaywidth
	PositionEntity hudoverlay, -1, aspect, 1
	scale# = 2.0 / displaywidth
	ScaleEntity hudoverlay, scale, -scale, scale
End Function









;
;
;
;
;

